import "Turbine"; -- required to expose the chat control
import "Turbine.Gameplay"; -- required to expose the Alignment control (not used yet)
import "Turbine.UI"; -- exposes the label control 
import "Turbine.UI.Lotro"; -- exposes the standard LOTRO window elements

-- TO DO
-- Work out how to detect pet names
-- I don't want to do yet another a DPS meter, but perhaps track highest hit for the session?

-- Yes, I know the coding is crap
-- This is my first cut just to prove it can be done and to teach myself the basics
-- I have never programmed in C and never in LUA so go easy on me!

-- V1.0.0	initial test build for limited release
-- V1.0.1	Remove period from KB name, changed text colour
-- V1.0.2	Fix DP over 999 and change to floating text
-- V1.0.3	Add Death count and allow for future display options
-- V1.0.4	Add options window, save options, allow opacity and displayed counters to be selected
-- V1.0.5	Implement window movement via standard <cntrl>\ UI method - First public release
-- V1.0.6	Allow Renown to be logged when playing Freepside
-- V1.0.7	Provide an option to save stats on exit
-- V2.0.0   Changes for U6. Remove DP. Introduce Commendations. Change chat channels.
-- V2.0.1   Fixed bug with group members earning commendations

local aquired = " acquired ";
local corpse = "";
local corpseTime = 120;
local death=" incapacitated you";
local earnts = "You've earned ";
local first = 0;
local freepKill = "Your mighty blow topples ";
local last = 0;
local lastKbTime = 0;
local LogWindowMoveToggle = false;
local npcKill = "Your mighty blow defeated ";
local petName = "this_doesnt_work_yet"; -- temporary. U6 bought a fix, yet to implement
local pointsType = "Points: ";
local yourdpe = " destiny points."; -- May need to be removed
local yourcommendationse = " Commendations].";
local youraquired = "You have acquired ";
local yourinfe = " infamy points.";
local yourrene = " renown points.";
local ver = "2.0.1";

LogWindow=Turbine.UI.Window();

		LogWindow.saveData = Turbine.PluginData.Load( Turbine.DataScope.Character,  "PvMPLog")

			if (LogWindow.saveData==nil) or (LogWindow.saveData.ver~="2.0.0") then
				LogWindow.saveData = { };
				LogWindow.saveData.ver=ver;
				LogWindow.saveData.x=(Turbine.UI.Display:GetWidth()/2 -100);
				LogWindow.saveData.y=5;
				LogWindow.saveData.opacity=0.5;
				LogWindow.saveData.deathUI=1;
				LogWindow.saveData.commUI=1;
				LogWindow.saveData.kbUI=1;
				LogWindow.saveData.pointsUI=1;
				LogWindow.saveData.saveUI=0;
				LogWindow.saveData.pointsTotal=0;
				LogWindow.saveData.kbTotal=0;
				LogWindow.saveData.commTotal=0;
				LogWindow.saveData.deathTotal=0;
				Turbine.Shell.WriteLine("PvMPLog new or upgraded. Options reset to defaults. Ver " .. ver .. " loaded");
			else
				Turbine.Shell.WriteLine("PvMPLog Ver " .. ver .. " loaded");
			end

		local deathUI = LogWindow.saveData.deathUI;
		local commUI = LogWindow.saveData.commUI;
		local kbUI = LogWindow.saveData.kbUI;
		local pointsUI = LogWindow.saveData.pointsUI;
		local saveUI = LogWindow.saveData.saveUI;

		if LogWindow.saveData.pointsTotal == nil then pointsTotal=0 else pointsTotal = LogWindow.saveData.pointsTotal end
		if LogWindow.saveData.kbTotal == nil then kbTotal=0 else kbTotal = LogWindow.saveData.kbTotal end
		if LogWindow.saveData.commTotal == nil then commTotal=0 else commTotal = LogWindow.saveData.commTotal end
		if LogWindow.saveData.deathTotal == nil then deathTotal=0 else deathTotal = LogWindow.saveData.deathTotal end

		local opacity = LogWindow.saveData.opacity

		LogWindow:SetSize(200,130);
		LogWindow:SetZOrder(0);
		LogWindow:SetPosition(LogWindow.saveData.x, LogWindow.saveData.y);
		LogWindow:SetBackColor(Turbine.UI.Color(0,0,0,0));
		
	
		LogWindow.Points=Turbine.UI.Label(); 
		LogWindow.Points:SetParent(LogWindow); 
		LogWindow.Points:SetSize(180,25); 
		if (pointsUI==1) then pointsPos=20 else pointsPos=0 end
		LogWindow.Points:SetPosition(40,pointsPos); 
		LogWindow.Points:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		LogWindow.Points:SetForeColor(Turbine.UI.Color(1,1,0.84,0));
		LogWindow.Points:SetTextAlignment(Turbine.UI.ContentAlignment.Left);
		
		LogWindow.Kb=Turbine.UI.Label();
		LogWindow.Kb:SetParent(LogWindow);
		LogWindow.Kb:SetSize(180,25);
		if (pointsUI==1) then kbPos=45 else kbPos=20 end
		LogWindow.Kb:SetPosition(40,kbPos);
		LogWindow.Kb:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		LogWindow.Kb:SetForeColor(Turbine.UI.Color(1,1,0.84,0));
		LogWindow.Kb:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

		LogWindow.Comm=Turbine.UI.Label(); 
		LogWindow.Comm:SetParent(LogWindow); 
		LogWindow.Comm:SetSize(180,25);
		if (pointsUI==0) and (kbUI==0) then commPos=20
		 elseif (pointsUI==1) and (kbUI==1) then commPos=70
		 elseif (pointsUI==0) or (kbUI==0) then commPos=45
		end
		LogWindow.Comm:SetPosition(40,commPos); 
		LogWindow.Comm:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		LogWindow.Comm:SetForeColor(Turbine.UI.Color(1,1,0.84,0));
		LogWindow.Comm:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

		LogWindow.death=Turbine.UI.Label(); 
		LogWindow.death:SetParent(LogWindow); 
		LogWindow.death:SetSize(180,25);
		if (pointsUI==0) and (kbUI==0) and (commUI==0) then deathPos=20
		 elseif (pointsUI+kbUI+commUI==1) then deathPos=45
		 elseif (pointsUI+kbUI+commUI==2) then deathPos=70
		 elseif (pointsUI+kbUI+commUI==3) then deathPos=95
		end
		LogWindow.death:SetPosition(40,deathPos); 
		LogWindow.death:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		LogWindow.death:SetForeColor(Turbine.UI.Color(1,1,0.84,0));
		LogWindow.death:SetTextAlignment(Turbine.UI.ContentAlignment.Left);

		LogWindow:SetOpacity( opacity );
		LogWindow:SetVisible(true); 
		LogWindow:SetWantsKeyEvents(true);

		if (pointsUI==1) then
			LogWindow.Points:SetText("Points: " .. pointsTotal);
		end
		if (kbUI==1) then
			LogWindow.Kb:SetText("KB:  " .. kbTotal);
		end
		if (commUI==1) then
			LogWindow.Comm:SetText("Comm:  " .. commTotal);
		end
		if (deathUI==1) then
			LogWindow.death:SetText("Deaths: " .. deathTotal);
		end


	optionsWindow=Turbine.UI.Lotro.GoldWindow();
		optionsWindow:SetSize(340,205);
		optionsWindow:SetPosition(Turbine.UI.Display:GetWidth()/2 -100, Turbine.UI.Display:GetHeight()/2 -100);
		optionsWindow:SetText( "PvMPLog " .. ver .. " Options" );
		optionsWindow:SetOpacity( 1.0 );
		optionsWindow:SetVisible(false); 
		optionsWindow:SetWantsKeyEvents(true);

	optionsWindow.checkbox1 = Turbine.UI.Lotro.CheckBox();
		optionsWindow.checkbox1:SetParent( optionsWindow );
		optionsWindow.checkbox1:SetPosition( 20, 40 );
		optionsWindow.checkbox1:SetSize( 180,25 );
		optionsWindow.checkbox1:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		optionsWindow.checkbox1:SetTextAlignment( Turbine.UI.CheckBox.Center );
		optionsWindow.checkbox1:SetText( " Killing Blows" );
		if kbUI==1 then optionsWindow.checkbox1:SetChecked(1) else optionsWindow.checkbox1:SetChecked(nil) end

	optionsWindow.checkbox2 = Turbine.UI.Lotro.CheckBox();
		optionsWindow.checkbox2:SetParent( optionsWindow );
		optionsWindow.checkbox2:SetPosition( 20, 65 );
		optionsWindow.checkbox2:SetSize( 180,25 );
		optionsWindow.checkbox2:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		optionsWindow.checkbox2:SetTextAlignment( Turbine.UI.CheckBox.Center );
		optionsWindow.checkbox2:SetText( " Commendations" );
		if commUI==1 then optionsWindow.checkbox2:SetChecked(1) else optionsWindow.checkbox2:SetChecked(nil) end

	optionsWindow.checkbox3 = Turbine.UI.Lotro.CheckBox();
		optionsWindow.checkbox3:SetParent( optionsWindow );
		optionsWindow.checkbox3:SetPosition( 20, 90 );
		optionsWindow.checkbox3:SetSize( 170,25 );
		optionsWindow.checkbox3:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		optionsWindow.checkbox3:SetTextAlignment( Turbine.UI.CheckBox.Center );
		optionsWindow.checkbox3:SetText( " Deaths" );
		if deathUI==1 then optionsWindow.checkbox3:SetChecked(1) else optionsWindow.checkbox3:SetChecked(nil) end

	optionsWindow.checkbox4 = Turbine.UI.Lotro.CheckBox();
		optionsWindow.checkbox4:SetParent( optionsWindow );
		optionsWindow.checkbox4:SetPosition( 20, 115 );
		optionsWindow.checkbox4:SetSize( 220,25 );
		optionsWindow.checkbox4:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		optionsWindow.checkbox4:SetTextAlignment( Turbine.UI.CheckBox.Center );
		optionsWindow.checkbox4:SetText( " Save Stats On Exit" );
		if saveUI==1 then optionsWindow.checkbox4:SetChecked(1) else optionsWindow.checkbox4:SetChecked(nil) end

	optionsWindow.button1 = Turbine.UI.Lotro.Button();
		optionsWindow.button1:SetParent( optionsWindow );
		optionsWindow.button1:SetPosition( 80, 143 );
		optionsWindow.button1:SetSize( 170,25 );
		optionsWindow.button1:SetFont(Turbine.UI.Lotro.Font.TrajanPro20);
		optionsWindow.button1:SetText( "Clear Stats" );


LogWindow.MovePanel=Turbine.UI.Control();
	LogWindow.MovePanel:SetParent(LogWindow);
	LogWindow.MovePanel:SetSize(173,19);
	LogWindow.MovePanel:SetBackColor(Turbine.UI.Color(.5,0,0,0));
	LogWindow.MoveTopBar=Turbine.UI.Control();
	LogWindow.MoveTopBar:SetParent(LogWindow.MovePanel);
	LogWindow.MoveTopBar:SetSize(156,12);
	LogWindow.MoveTopBar:SetPosition(17,2);
	LogWindow.MoveTopBar:SetBackground("Creep/PvMPLog/Resources/MoveTopBar.tga");
	LogWindow.MoveTopBar:SetMouseVisible(false);
	LogWindow.MoveIcon=Turbine.UI.Control();
	LogWindow.MoveIcon:SetParent(LogWindow.MovePanel);
	LogWindow.MoveIcon:SetSize(19,19);
	LogWindow.MoveIcon:SetBackground("Creep/PvMPLog/Resources/MoveIcon.tga");
	LogWindow.MoveIcon:SetMouseVisible(false);
	LogWindow.MoveText=Turbine.UI.Label();
	LogWindow.MoveText:SetParent(LogWindow.MovePanel);
	LogWindow.MoveText:SetSize(156,12);
	LogWindow.MoveText:SetPosition(17,2);
	LogWindow.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
	LogWindow.MoveText:SetText("PvMPLog");
	LogWindow.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	LogWindow.MoveText:SetMouseVisible(false);
	LogWindow.MovePanel:SetVisible(false);

	LogWindow.MoveX=-1;
	LogWindow.MoveY=0;
	LogWindow.Moving=false;

	LogWindow.MovePanel.MouseDown=function()
	end

	LogWindow.MovePanel.MouseClick = function(sender,args)
		if LogWindow.Moving then
			LogWindow.Moving=false;
			LogWindow.MoveX=-1;
		end
	end
	LogWindow.MovePanel.MouseDown=function(sender,args)
		LogWindow.MoveX=args.X;
		LogWindow.MoveY=args.Y;
	end
	LogWindow.MovePanel.MouseUp=function(sender,args)
		LogWindow.MoveX=-1;
		LogWindow.MoveY=0;
	end

	LogWindow.MovePanel.MouseEnter=function(sender,args)
		LogWindow:SetOpacity(1);
	end

	LogWindow.MovePanel.MouseLeave=function(sender,args)
		LogWindow:SetOpacity(opacity);
	end
	LogWindow.MovePanel.MouseMove=function(sender,args)
		if LogWindow.MoveX~=-1 and (args.X~=LogWindow.MoveX or args.Y~= LogWindow.MoveY) then
			LogWindow.Moving=true;
			local newLeft=LogWindow:GetLeft()-(LogWindow.MoveX-args.X)
			local newTop=LogWindow:GetTop()-(LogWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(Turbine.UI.Display.GetWidth()-LogWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-LogWindow:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(Turbine.UI.Display.GetHeight()-LogWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-LogWindow:GetHeight() end;
			LogWindow:SetPosition(newLeft,newTop);
		end
	end


	optionsWindow.checkbox1.CheckedChanged = function(sender, args)
		if optionsWindow.checkbox1:IsChecked () then kbUI=1 else kbUI=0 end
		if (pointsUI==1) then kbPos=45 else kbPos=20 end
		if (pointsUI==0) and (kbUI==0) then commPos=20
			elseif (pointsUI==1) and (kbUI==1) then commPos=70
			elseif (pointsUI==0) or (kbUI==0) then commPos=45
		end
		if (pointsUI==0) and (kbUI==0) and (commUI==0) then deathPos=20
		 elseif (pointsUI+kbUI+commUI==1) then deathPos=45
		 elseif (pointsUI+kbUI+commUI==2) then deathPos=70
		 elseif (pointsUI+kbUI+commUI==3) then deathPos=95
		end
		LogWindow.Points:SetPosition(40,pointsPos); 
		LogWindow.Kb:SetPosition(40,kbPos);
		LogWindow.Comm:SetPosition(40,commPos);
		LogWindow.death:SetPosition(40,deathPos);
		if kbUI==1 then LogWindow.Kb:SetText("KB:  " .. kbTotal) else LogWindow.Kb:SetText("") end
		if commUI==1 then LogWindow.Comm:SetText("Comm:  " .. commTotal) else LogWindow.Comm:SetText("") end
		if pointsUI==1 then LogWindow.Points:SetText(pointsType .. pointsTotal) else LogWindow.Points:SetText("") end
		if deathUI==1 then LogWindow.death:SetText("Deaths: " .. deathTotal) else LogWindow.death:SetText("") end
	end


	optionsWindow.checkbox2.CheckedChanged = function(sender, args)
		if optionsWindow.checkbox2:IsChecked () then commUI=1 else commUI=0 end
		if (pointsUI==1) then kbPos=45 else kbPos=20 end
		if (pointsUI==0) and (kbUI==0) then commPos=20
			elseif (pointsUI==1) and (kbUI==1) then commPos=70
			elseif (pointsUI==0) or (kbUI==0) then commPos=45
		end
		if (pointsUI==0) and (kbUI==0) and (commUI==0) then deathPos=20
		 elseif (pointsUI+kbUI+commUI==1) then deathPos=45
		 elseif (pointsUI+kbUI+commUI==2) then deathPos=70
		 elseif (pointsUI+kbUI+commUI==3) then deathPos=95
		end
		LogWindow.Points:SetPosition(40,pointsPos); 
		LogWindow.Kb:SetPosition(40,kbPos);
		LogWindow.Comm:SetPosition(40,commPos);
		LogWindow.death:SetPosition(40,deathPos);
		if kbUI==1 then LogWindow.Kb:SetText("KB:  " ..kbTotal) else LogWindow.Kb:SetText("") end
		if commUI==1 then LogWindow.Comm:SetText("Comm:  " .. commTotal) else LogWindow.Comm:SetText("") end
		if pointsUI==1 then LogWindow.Points:SetText(pointsType .. pointsTotal) else LogWindow.Points:SetText("") end
		if deathUI==1 then LogWindow.death:SetText("Deaths: " .. deathTotal) else LogWindow.death:SetText("") end
	end

	optionsWindow.checkbox3.CheckedChanged = function(sender, args)
		if optionsWindow.checkbox3:IsChecked () then deathUI=1 else deathUI=0 end
		if (pointsUI==1) then kbPos=45 else kbPos=20 end
		if (pointsUI==0) and (kbUI==0) then commPos=20
			elseif (pointsUI==1) and (kbUI==1) then commPos=70
			elseif (pointsUI==0) or (kbUI==0) then commPos=45
		end
		if (pointsUI==0) and (kbUI==0) and (commUI==0) then deathPos=20
		 elseif (pointsUI+kbUI+commUI==1) then deathPos=45
		 elseif (pointsUI+kbUI+commUI==2) then deathPos=70
		 elseif (pointsUI+kbUI+commUI==3) then deathPos=95
		end
		LogWindow.Points:SetPosition(40,pointsPos); 
		LogWindow.Kb:SetPosition(40,kbPos);
		LogWindow.Comm:SetPosition(40,commPos);
		LogWindow.death:SetPosition(40,deathPos);
		if kbUI==1 then LogWindow.Kb:SetText("KB:  " ..kbTotal) else LogWindow.Kb:SetText("") end
		if commUI==1 then LogWindow.Comm:SetText("Comm:  " .. commTotal) else LogWindow.Comm:SetText("") end
		if pointsUI==1 then LogWindow.Points:SetText(pointsType .. pointsTotal) else LogWindow.Points:SetText("") end
		if deathUI==1 then LogWindow.death:SetText("Deaths: " .. deathTotal) else LogWindow.death:SetText("") end
	end

	optionsWindow.checkbox4.CheckedChanged = function(sender, args)
		if optionsWindow.checkbox4:IsChecked () then saveUI=1 else saveUI=0 end
	end

	optionsWindow.button1.MouseClick = function()
		pointsTotal = 0;
		LogWindow.Points:SetText(pointsType .. pointsTotal);
		kbTotal = 0;
		if (kbUI==1) then
			LogWindow.Kb:SetText("KB:  " ..kbTotal);
		end
		commTotal = 0;
		if (commUI==1) then
			LogWindow.Comm:SetText("Comm:  " .. commTotal);
		end
		deathTotal = 0;
		if (deathUI==1) then
			LogWindow.death:SetText("Deaths: " .. deathTotal);
		end
	end

	optionsWindow.opacityScrollBar=Turbine.UI.Lotro.ScrollBar();
		optionsWindow.opacityScrollBar:SetParent( optionsWindow);
		optionsWindow.opacityScrollBar:SetPosition( 20, 170);
		optionsWindow.opacityScrollBar:SetSize( 300, 10 );
		optionsWindow.opacityScrollBar:SetMinimum( 0 );
		optionsWindow.opacityScrollBar:SetMaximum( 200 );
		optionsWindow.opacityScrollBar:SetValue( 0.5 );
		optionsWindow.opacityScrollBar:SetOrientation( Turbine.UI.Orientation.Horizontal );

	optionsWindow.opacityScrollBar.ValueChanged = function( sender, args )
		LogWindow:SetOpacity( ( 55 + ( 200 - optionsWindow.opacityScrollBar:GetValue() ) ) / 255 );
		opacity = ( 55 + ( 200 - optionsWindow.opacityScrollBar:GetValue() ) ) / 255;

	end


LogWindow.KeyDown = function(sender,args) 
    if (args.Action == 268435635) then -- F12
        if(LogWindow:IsVisible() == true )then
            LogWindow:SetVisible(false)
        else
            LogWindow:SetVisible(true)
        end
    elseif ( args.Action == 268435579 ) then -- <Cntrl>\
		LogWindowMoveToggle=not LogWindowMoveToggle;
		LogWindow.MovePanel:SetVisible(LogWindowMoveToggle);
	end
end

LogWindow.Points.MouseClick=function(sender,args)
	if args.Button==2 then
		optionsWindow:SetVisible(true); 
	end
end

if ( Plugins ["PvMPLog"] ~= nil ) then
	Plugins["PvMPLog"].Unload = function( sender, args )
		LogWindow.saveData.x,LogWindow.saveData.y=LogWindow:GetPosition()
		LogWindow.saveData.opacity = opacity;
		LogWindow.saveData.deathUI = deathUI;
		LogWindow.saveData.commUI = commUI;
		LogWindow.saveData.kbUI = kbUI;
		LogWindow.saveData.pointsUI = pointsUI;
		LogWindow.saveData.saveUI = saveUI;
		if (saveUI==1) then
			LogWindow.saveData.pointsTotal = pointsTotal;
			LogWindow.saveData.kbTotal = kbTotal;
			LogWindow.saveData.commTotal = commTotal;
			LogWindow.saveData.deathTotal = deathTotal;
		else
			LogWindow.saveData.pointsTotal = 0;
			LogWindow.saveData.kbTotal = 0;
			LogWindow.saveData.commTotal = 0;
			LogWindow.saveData.deathTotal = 0;
		end
		Turbine.PluginData.Save( Turbine.DataScope.Character, "PvMPLog", LogWindow.saveData );
		-- Turbine.Shell.WriteLine("PvMPLog data saved!");
	end
end


Turbine.Chat.Received=function(sender, args)


	if ((Turbine.Engine.GetGameTime()) - lastKbTime > corpseTime) and kbUI==1 then -- Reset last corpse text if more than x seconds ago
		LogWindow.Kb:SetText("KB:  " .. kbTotal);
	end

	 -- Comment this out for the live version
	 -- for k, v in pairs(args) do
	 -- 	Turbine.Shell.WriteLine(k .. ": " .. tostring(v));
	 -- end

	
	-- Pet KB's disabled until I can work out a way of seperating Freep's from NPC's.
	--if (args.ChatType==524288) and string.find(args.Message, petName .. " defeated ") ~= nil then -- check for a pet kill (Set pet name in variables section)
			--s,e = string.find (args.Message, "defeated "); -- find the end position of the defeat message
			--e=e+1; -- add one to equal the start position of the defeated characters name
			--corpse = string.sub(args.Message, e); -- get the defeated characters name
			
				--if string.find (args.Message, "the ") == 27 then -- remove "the" if it appears at the start of an NPC name
					--corpse = string.sub(corpse, 5);
				--end

			--kbTotal=kbTotal+1;
			--lastKbTime=(Turbine.Engine.GetGameTime());
			--LogWindow.Kb:SetText("KB:  " .. kbTotal .. " " .. corpse);


	--elseif (args.ChatType==524288) and string.find (args.Message, freepKill) or string.find(args.Message, petName .. " defeated") ~= nil then -- check for one of our kills
	if (args.ChatType==20) and string.find (args.Message, freepKill) ~= nil then -- check for one of our kills
	--elseif (args.ChatType==524288) and string.find (args.Message, freepKill) ~= nil then -- check for one of our kills
			s,e = string.find (args.Message, freepKill); 
			e=e+1; 
			corpse = string.gsub(string.sub(args.Message, e), "%.", ""); 
			kbTotal=kbTotal+1;
			lastKbTime=(Turbine.Engine.GetGameTime());
			if (kbUI==1) then
				LogWindow.Kb:SetText("KB:  " ..kbTotal .." " .. corpse);
			end



	elseif (args.ChatType==4) and string.find (args.Message, yourcommendationse) ~= nil and string.find (args.Message, youraquired) then -- check for earnt Commendations
			s,e = string.find (args.Message, aquired);
			first=e+48; -- Add 48 to skip the opening square bracket plus the internal code crap
			s,e = string.find (args.Message, "]"); 
			last=s-15; -- 15 before closing square bracket should be last digit of earnt commendations
			Comm = string.sub(args.Message, first, last );
			commTotal=commTotal + tonumber(Comm);
			if (commUI==1) then
				LogWindow.Comm:SetText("Comm:  " .. commTotal); 
			end


	elseif (args.ChatType==8192) or (args.ChatType==14) and string.find (args.Message, yourinfe) ~= nil then -- check for earnt Infamy
			local pointsType = "Inf: ";
			s,e = string.find (args.Message, earnts); 
			first=e+1;
			s,e = string.find (args.Message, yourinfe);
			last=s-1;
			PointsEarnt = string.sub(args.Message, first, last );
			pointsTotal=pointsTotal + tonumber(PointsEarnt);	
			if (pointsUI==1) then
				LogWindow.Points:SetText(pointsType .. pointsTotal);
			end

	elseif (args.ChatType==8192) or (args.ChatType==14) and string.find (args.Message, yourrene) ~= nil then -- check for earnt Renown
			local pointsType = "Ren: ";
			s,e = string.find (args.Message, earnts); 
			first=e+1;
			s,e = string.find (args.Message, yourrene);
			last=s-1;
			PointsEarnt = string.sub(args.Message, first, last );
			pointsTotal=pointsTotal + tonumber(PointsEarnt);	
			if (pointsUI==1) then
				LogWindow.Points:SetText(pointsType .. pointsTotal);
			end

	elseif (args.ChatType==20) and string.find (args.Message, death) ~= nil then -- check for your own death
			Turbine.Shell.WriteLine("Detected death");
			deathTotal=deathTotal + 1;	
			if (deathUI==1) then
				LogWindow.death:SetText("Deaths: " .. deathTotal);
			end

	end
end
